; Wolfram Hildebrandt
; wolfi-home@lycos.de



.nolist
.include "m8def.inc"
.list



.equ	E	= 0
.equ	RW	= 1
.equ	RS	= 2
.equ	led = 3

.equ	port_display = PORTD
.equ	ddr_display	= DDRD
.equ	pin_display	= PIND
.equ	port_Steuer = PORTC
.equ	ddr_steuer = DDRC
.equ	pin_steuer = PINC


.equ	command=0x65



.org 0x0000
rjmp	reset

reset:
; Stackpointer
ldi	r16, low(RAMEND)
ldi	r17, high(RAMEND)
out	SPL, r16
out SPH, r17

ldi	r16, 0b11111111
out	ddr_steuer, r16
out	ddr_display, r16		; Display Port auf Ausgang

ldi	r16, 0x00
out port_display, r16
out port_steuer, r16




rcall	init_lcd

ldi		r16, 'A'
sts		command, r16
rcall	send_data



ende:
rjmp ende

;--------------------------
init_lcd:
rcall	delay_40ms

ldi		r16, 0b00111001
sts		command, r16
rcall	send_n_chk
rcall	delay_30us

ldi		r16, 0b00111001
sts		command, r16
rcall	send_n_chk
rcall	delay_30us

ldi		r16, 0b00011100
sts		command, r16
rcall	send_command
rcall	delay_30us			; bias

ldi		r16, 0b01010010
sts		command, r16
rcall	send_command
rcall	delay_30us			; power control

	; bis hier geht es

ldi		r16, 0b01101001
sts		command, r16
rcall	send_command
rcall	delay_30us			; follower control

ldi		r16, 0b01110100
sts		command, r16
rcall	send_command
rcall	delay_30us			; contrast

ldi		r16, 0b00001111
sts		command, r16
rcall	send_command
rcall	delay_30us			; display an

ldi		r16, 0b00000001
sts		command, r16
rcall	send_command
rcall	delay_40ms			; display clear

ldi		r16, 0b00000110
sts		command, r16
rcall	send_command
rcall	delay_30us			; entry mode


sbi		port_Steuer, led

ret


;---------------------------------------
send_data:
rcall	check_busy

sbi		port_steuer, rs
cbi		port_steuer, rw
lds		r16, command
out		port_display, r16
sbi		port_steuer, e
nop
nop
nop
nop
nop
cbi		port_steuer, e

ret
;----------------------------------------
send_command:
rcall	check_busy
send_n_chk:
cbi		port_steuer, rs
cbi		port_steuer, rw
lds		r16, command
out		port_display, r16
sbi		port_steuer, e
nop
nop
nop
nop
nop
cbi		port_steuer, e


ret
;----------------------------------------
check_busy:
ldi		r16, 0x00
out		ddr_display, r16

ldi		r16, 0xFF
out		port_display, r16		; pullups aus

chk:
cbi		port_steuer, rs
sbi		port_steuer, rw
sbi		port_steuer, e
sbic 	pin_display, 7		; wenn null, nicht busy, dann berpsringen
rjmp	chk 

cbi		port_steuer, e

ldi		r16, 0xFF
out		ddr_display, r16

ret





delay_40ms:
; ============================= 
;    delay loop generator 
;     40000  cycles:
; ----------------------------- 
; delaying 39999 cycles:
          ldi  R17, $42
WGLOOP0:  ldi  R18, $C6
WGLOOP1:  dec  R18
          brne WGLOOP1
          dec  R17
          brne WGLOOP0
; ----------------------------- 
; delaying 1 cycle:
          nop
; ============================= 
ret

delay_30us:
; ============================= 
;    delay loop generator 
;     30 cycles :
; ----------------------------- 
; delaying 30 cycles:
          ldi  R17, $0C
WGLOOP0b:  dec  R17
          brne WGLOOP0b
; ============================= 
ret
