// Wolfram Hildebrandt
// wolfi-home@lycos.de


#include <main.h>

//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void lcd_init(void)
{
DDR_display   = 0xFF;			// Ausgang

PORT_display = 0x00;


// init nach datenblatt fr 4-bit mode:

// delay.h einbinden !!!!!!!!!!!!!!

delay_40ms();


lcd_write_no_busy_flg(0b00110000);	//function set 8 bit, dl 0					
delay_2ms();

lcd_write_no_busy_flg(0b00110000);	//function set 8 bit, dl 0					
delay_30us();;

lcd_write_no_busy_flg(0b00110000);	//function set 8 bit, dl 0					
delay_30us();

lcd_check_busy();
lcd_write_no_busy_flg(0b00100000);	//function set 4 bit
delay_30us();

lcd_write(0b00101001, 0);			// function set 4 bit, 2line display
delay_30us();				

lcd_write(0b00011100, 0);			// bias
delay_30us();

lcd_write(0b01010010, 0);			// 3v booster aus, power control
delay_30us();

lcd_write(0b01101001, 0);			// follover control
delay_30us();

lcd_write(0b01110100, 0);			// contrast set
delay_30us();

lcd_write(0b00001111, 0);			// display on
delay_30us();

lcd_write(0b00000001, 0);			// clear display
delay_2ms();

lcd_write(0b00000110, 0);			// entry mode auto increment
delay_30us();;
}
//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void lcd_write(char command, char daten)
{
	char command_save=0;
	command_save = command;

	lcd_check_busy();
	
// Befehl an Display-Port anlegen, dabei die restlichen vier Steuerbits (E, RW, RS) auf Null setzen
	command &= 0xF0;				// low nibble von Command auf Null setzen.
	PORT_display = command;	

// Befehl schreiben (high-nibble):
	
	if (daten==0)
	{
		PORT_display &= ~(1<<RS);		// es handelt sich um ein Kommando
	}
	if (daten==1)
	{
		PORT_display |= (1 << RS);		// es handelt sich um Daten
	}
	
	
	PORT_display &= ~(1<<RW);
	PORT_display |= (1 << E);		// enable

	asm volatile ("nop");			// 1 s zum Verarbeiten fr das Display
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
		
								
	
	PORT_display &= ~(1<<E);			// disable

// low nibble vorbereiten:
	command_save <<= 4; 				// um 4 nach links verschieben, mit null auffllen
	command_save &= 0xF0;
	PORT_display = command_save;

// Befehl schreiben (low-nibble):
	if (daten==0)
	{
		PORT_display &= ~(1<<RS);		// es handelt sich um ein Kommando
	}
	if (daten==1)
	{
		PORT_display |= (1 << RS);		// es handelt sich um Daten
	}

	PORT_display &= ~(1<<RW);		
	PORT_display |= (1 << E);		// enable

	asm volatile ("nop");			// 1 s zum Verarbeiten fr das Display
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	

	PORT_display &= ~(1<<E);			// disable

}
//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void lcd_write_no_busy_flg(char command)
{
	command &= 0xF0;
	PORT_display = command;	

// Befehl schreiben (high-nibble):
	PORT_display &= ~(1<<RS);
	PORT_display &= ~(1<<RW);		
	PORT_display |= (1 << E);		// enable

	asm volatile ("nop");			// 1 s zum Verarbeiten fr das Display
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	

	PORT_display &= ~(1<<E);			// disable
}
//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void lcd_check_busy(void)
{
// D7-D4 auf Eingang schalten:
	DDR_display = 0x0F;
	
	busy_test();

	// D7-D4 auf Ausgang schalten:
	DDR_display =0xFF;



}


void busy_test(void)
{
uint8_t temp;

temp = 0xFF;

// D7: BusyFlag = 0: not busy
while (bit_is_set (temp,7)) 
 // solange D7 gesetzt ist, nicht weitermachen
{ 
	// RS low, RW high: High-Nibble des Display-Bytes mit Adresse und BusyFlag lesen:
		PORT_display &= ~(1<<RS);
		PORT_display |= (1 << RW);
		PORT_display |= (1 << E);		// enable

	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	
			
		temp = PIN_display;	         	// das high-nibble des displays liegt jetzt im high-nibble von temp
		PORT_display &= ~(1<<E);		    // disable

	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");


	// low nibble verwerfen:
		PORT_display |= (1 << E);		// enable

	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	asm volatile ("nop");	
	
		PORT_display &= ~(1<<E);		    // disable

	
	}
}



//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void delay_30us(void)
{
uint8_t i;

for(i=1;i<=3;i++)
{
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
} 
}


//-------------------------------------------
void delay_2ms(void)
{
uint8_t i;

for(i=1;i<=200;i++)
{
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
} 
}
//-------------------------------------------
void delay_40ms(void)
{
uint16_t i;

for(i=1;i<=4000;i++)
{
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
} 
}





