// Wolfram Hildebrandt
// wolfi-home@lycos.de


#include <main.h>

//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void lcd_init(void)
{


PORT_display |= (1 << SCL);

// 5V SPI
// erfordert eine echten hardware reset; bei 4 und 8 bit nicht.

delay_40ms();


lcd_write(0b00111000, 0);			//function set 					
delay_30us();

lcd_write(0b00111001, 0);			//function set 					
delay_30us();

lcd_write(0b00011100, 0);			// bias
delay_30us();

lcd_write(0b01010010, 0);			// 3v booster aus, power control
delay_30us();

lcd_write(0b01101001, 0);			// follover control
delay_200ms();

// mit diesem folloverwert kann der contrast max. auf 6,18V gesetzt werden. max 7V erlaubt
// vgl. st7036 seite 52

lcd_write(0b01110100, 0);			// contrast set
delay_30us();

lcd_write(0b00001111, 0);			// display on
delay_30us();

lcd_write(0b00000001, 0);			// clear display
delay_2ms();

lcd_write(0b00000110, 0);			// entry mode auto increment
delay_30us();;
}
//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void lcd_write(char command, char daten)
{
	
	if (daten==0)
		{
		PORT_display &= ~(1<<RS);		// es handelt sich um ein Kommando
		}
	if (daten==1)
		{
		PORT_display |= (1 << RS);		// es handelt sich um Daten
		}

uint8_t l=0;

for (l=7; l<255; l--)
  {
	if (command & (1 << l))
		{	
	 	PORT_display |= (1 << SI);		// 1 Datenbit anlegen
		}
	else
		{
		PORT_display &= ~(1<<SI);		// 0 Datenbit anlegen
		}

	PORT_display |= (1 << SCL);
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	
	PORT_display &= ~(1<<SCL);
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");



  }

delay_2ms();



}



//---------------------------------------------------
//---------------------------------------------------
//---------------------------------------------------
void delay_30us(void)
{
uint8_t i;

for(i=1;i<=3;i++)
{
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
} 
}


//-------------------------------------------
void delay_2ms(void)
{
uint8_t i;

for(i=1;i<=200;i++)
{
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
} 
}
//-------------------------------------------
void delay_40ms(void)
{
uint16_t i;

for(i=1;i<=4000;i++)
{
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
} 
}

//-------------------------------------------
void delay_200ms(void)
{
uint16_t i;

for(i=1;i<=20000;i++)
{
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
asm volatile ("nop");
} 
}
//-------------------------------------------





