; Wolfram Hildebrandt
; wolfi-home@lycos.de


	list p=18f252

	#include <P18f252.INC> 

; 1 Mhz intern
; ea dogm 162 display
 
; PORTC: 7-D7 vom Display... 4=D4
; steuerleitungen auch an portc

E		equ		0
RW		equ		1
RS		equ		2
Led		equ		4

port_display	equ		PORTC
tris_display	equ		TRISC



	org	.0
	goto	start





	cblock		0x25
loops
loops2
command
counter
temp
	endc
	

start 
; Null= Ausgang
; Eins = Eingang

	clrf	TRISA
	clrf	tris_display

	movlw	0x07
	movwf	ADCON1					; porta digital port

	bsf		PORTA, Led		; led aus

	clrf	port_display

	call	init_lcd

	movlw	'A'
	movwf	command
	call	send_data
	movlw	'B'
	movwf	command
	call	send_data
	movlw	'C'
	movwf	command
	call	send_data
	movlw	'D'
	movwf	command
	call	send_data
	movlw	'E'
	movwf	command
	call	send_data
	movlw	'F'
	movwf	command
	call	send_data
	movlw	'G'
	movwf	command
	call	send_data
	movlw	'H'
	movwf	command
	call	send_data

Ende	
	bcf		PORTA, Led		; led an
	movlw	.250
	movwf	loops
	call	WAIT
	bsf		PORTA, Led
	movlw	.250
	movwf	loops
	call	WAIT
	goto	Ende


init_lcd
	movlw	.40
	movwf	loops
	call	WAIT



	movlw	B'00110000'
	movwf	command
	call	send_n_chk
	movlw	.2
	movwf	loops
	call	WAIT

	movlw	B'00110000'
	movwf	command
	call	send_n_chk
	call	delay_30us

	movlw	B'00110000'
	movwf	command
	call	send_n_chk
	call	delay_30us

	call	check_busy
	movlw	B'00100000'
	movwf	command
	call	send_n_chk				; function set
	call	delay_30us

	movlw	B'00101001'
	movwf	command
	call	send_command				; function set
	call	delay_30us
	

	movlw	B'00011100'
	movwf	command			; bias
	call	send_command
	call	delay_30us

	movlw	B'01010010'
	movwf	command			; power control
	call	send_command
	call	delay_30us

	movlw	B'01101001'
	movwf	command			; follower control
	call	send_command
	call	delay_30us

	movlw	B'01110100'
	movwf	command			; contrast
	call	send_command
	call	delay_30us

	movlw	B'00001111'
	movwf	command			; display an
	call	send_command
	call	delay_30us

	movlw	B'00000001'
	movwf	command			; display clear, home
	call	send_command
	call	delay_30us

	movlw	B'00000110'
	movwf	command			; entry mode
	call	send_command
	call	delay_30us



	
	

	retlw	.0
;-----------------------------------------------------------
send_data
	call	check_busy

	movlw	0xF0
	andwf	command,w 
	movwf	port_display

	bsf		port_display, RS
	bcf		port_display, RW
	bsf		port_display, E
	nop
	nop							; wichtig, damit port richtig eingelesen werden kann, da display zeit zum schreiben bekommt !!
	bcf		port_display, E

	rlncf	command,f	
	rlncf	command,f
	rlncf	command,f
	rlncf	command,f
	movlw	0xF0
	andwf	command,w 
	movwf	port_display

	bsf		port_display, RS
	bcf		port_display, RW
	bsf		port_display, E
	nop
	nop
	bcf		port_display, E

	retlw	.0
;-----------------------------------------------------------
send_command
	call	check_busy

	movlw	0xF0
	andwf	command,w 
	movwf	port_display

	bcf		port_display, RS
	bcf		port_display, RW
	bsf		port_display, E
	nop
	nop
	bcf		port_display, E

	swapf	command

send_n_chk
	movlw	0xF0
	andwf	command,w 
	movwf	port_display

	bcf		port_display, RS
	bcf		port_display, RW
	bsf		port_display, E
	nop
	nop
	bcf		port_display, E

	retlw	.0
;-----------------------------------------------------------
check_busy
	movlw	0xF0
	movwf	tris_display

chk	
	bcf		port_display, RS
	bsf		port_display, RW
	bsf		port_display, E
	nop
	nop
	movf	port_display, w
	movwf	temp
	bcf		port_display, E 
	nop
	nop

	bsf		port_display, E
	nop
	nop
	bcf		port_display, E 

	btfsc	temp, 7
	goto	chk

	movlw	0x00
	movwf	tris_display

	retlw	.0
;**********************************************************
; Warteschleife 1 ms fr einen 4MHz-PIC-Takt

WAIT

Wai
        movlw   .110           ; Zeitkonstante fr 1ms
        movwf   loops2
Wai2    nop                    ; 
        nop
        nop
        nop
        nop
        nop
        decfsz  loops2, F      ; 1 ms vorbei?
        goto    Wai2           ; nein, noch nicht
                               ;
        decfsz  loops, F       ; 250 ms vorbei?
        goto    Wai            ; nein, noch nicht
        retlw   .0             ; das Warten hat ein Ende 



delay_30us
	movlw	.10
	movwf	counter
del
	decfsz	counter,f			; 1 Befehl
	goto	del					; 2 Befehle

	retlw	.0


	end
