; Wolfram Hildebrandt
; wolfi-home@lycos.de



	list p=18f252

	#include <P18f252.INC> 

; 1 Mhz intern

; ea dogm162 display mit zwei zeilen

; PORTC: 7-D7 vom Display... 0=D0
; PORTA: steuerleitungen

E		equ		0
RW		equ		1
RS		equ		2
RESETd	equ		3
Led		equ		4

port_display	equ		PORTC
tris_display	equ		TRISC

port_steuer		equ		PORTA 
tris_steuer		equ		TRISA


	org	.0
	goto	start





	cblock		0x25
loops
loops2
command
counter
	endc
	

start 
; Null= Ausgang
; Eins = Eingang

	clrf	tris_steuer
	clrf	tris_display

	movlw	0x07
	movwf	ADCON1					; porta digital port

	bcf		port_steuer, E
	bcf		port_steuer, RW
	bcf		port_steuer, RS
	bsf		port_steuer, Led		; led aus

	clrf	port_display

	call	init_lcd

	movlw	'A'
	movwf	command
	call	send_data
	movlw	'B'
	movwf	command
	call	send_data
	movlw	'C'
	movwf	command
	call	send_data
	movlw	'D'
	movwf	command
	call	send_data
	movlw	'E'
	movwf	command
	call	send_data
	movlw	'F'
	movwf	command
	call	send_data
	movlw	'G'
	movwf	command
	call	send_data
	movlw	'H'
	movwf	command
	call	send_data

Ende	
	bcf		port_steuer, Led		; led an
	movlw	.250
	movwf	loops
	call	WAIT
	bsf		port_steuer, Led
	movlw	.250
	movwf	loops
	call	WAIT
	goto	Ende


init_lcd
	movlw	.40
	movwf	loops
	call	WAIT


	movlw	B'00111001'
	movwf	command
	call	send_n_chk
	call	delay_30us

	movlw	B'00111001'
	movwf	command
	call	send_n_chk
	call	delay_30us

	movlw	B'00011100'
	movwf	command			; bias
	call	send_command
	call	delay_30us

	movlw	B'01010010'
	movwf	command			; power control
	call	send_command
	call	delay_30us

	movlw	B'01101001'
	movwf	command			; follower control
	call	send_command
	call	delay_30us

	movlw	B'01110100'
	movwf	command			; contrast
	call	send_command
	call	delay_30us

	movlw	B'00001111'
	movwf	command			; display an
	call	send_command
	call	delay_30us

	movlw	B'00000001'
	movwf	command			; display clear, home
	call	send_command
	call	delay_30us

	movlw	B'00000110'
	movwf	command			; entry mode
	call	send_command
	call	delay_30us



	
	

	retlw	.0
;-----------------------------------------------------------
send_data
	call	check_busy

	bsf		port_steuer, RS
	bcf		port_steuer, RW
	bsf		port_steuer, E
	movf	command,w
	movwf	port_display
	bcf		port_steuer, E

	retlw	.0
;-----------------------------------------------------------
send_command
	call	check_busy
send_n_chk
	bcf		port_steuer, RS
	bcf		port_steuer, RW
	bsf		port_steuer, E
	movf	command,w
	movwf	port_display
	bcf		port_steuer, E

	retlw	.0
;-----------------------------------------------------------
check_busy
	movlw	0xFF
	movwf	tris_display

chk	
	bcf		port_steuer, RS
	bsf		port_steuer, RW

	bsf		port_steuer, E
	btfsc	port_display, 7

	goto	chk

	bcf		port_steuer, E 

	movlw	0x00
	movwf	tris_display

	retlw	.0
;**********************************************************
; Warteschleife 1 ms fr einen 4MHz-PIC-Takt

WAIT

Wai
        movlw   .110           ; Zeitkonstante fr 1ms
        movwf   loops2
Wai2    nop                    ; 
        nop
        nop
        nop
        nop
        nop
        decfsz  loops2, F      ; 1 ms vorbei?
        goto    Wai2           ; nein, noch nicht
                               ;
        decfsz  loops, F       ; 250 ms vorbei?
        goto    Wai            ; nein, noch nicht
        retlw   .0             ; das Warten hat ein Ende 



delay_30us
	movlw	.10
	movwf	counter
del
	decfsz	counter,f			; 1 Befehl
	goto	del					; 2 Befehle

	retlw	.0


	end
